<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\Eloquent\SoftDeletes;

class PhotoFeedbackSubmissionsModel extends Model
{

    use SoftDeletes;

    protected $table = 'photo_feedback_submissions';
    private static $tableName = 'photo_feedback_submissions';

    private static $pf711TableName = 'photo_feedback_711';
    private static $payoutTable = 'qa_payout';

    public static $approved = 1;
    public static $disapproved = 0;

    public static function getSubmission($cust_id, $code)
    {
        // $sql = "SELECT *
        // FROM  " . static::$tableName . "
        // WHERE cust_id = '" . $cust_id . "' AND deleted_at IS NULL AND (status IS NULL OR status = '" . static::$disapproved . "') ORDER BY created_at DESC ";

        $sql = "SELECT *
        FROM  " . static::$tableName . "
        WHERE cust_id = '" . $cust_id . "' AND Code_B_Sticker = '" . $code . "' AND deleted_at IS NULL ORDER BY created_at DESC ";

        $submissions = DB::select($sql);
        return collect($submissions)->map(function ($x) {
            return (array) $x;
        })->toArray(); //return array
    }
    
    public static function chkSubmissionData($cust_id, $code)
    {        
        // $sql = "SELECT *
        // FROM  " . static::$tableName . "
        // WHERE cust_id = '" . $cust_id . "' AND task_id = '" . $taskId . "' AND deleted_at IS NULL AND status IS NULL ORDER BY created_at DESC ";
      
        $sql = "SELECT *
        FROM  " . static::$tableName . "
        WHERE cust_id = '" . $cust_id . "' AND Code_B_Sticker = '" . $code . "' AND deleted_at IS NULL AND status IS NULL ORDER BY created_at DESC ";

        $submissions = DB::select($sql);
        return collect($submissions)->map(function ($x) {
            return (array) $x;
        })->toArray(); //return array
    }

    public static function getApproved($cust_id, $code)
    {
        $sql = "SELECT *
                FROM  " . static::$tableName . "
                WHERE cust_id = '" . $cust_id . "' AND Code_B_Sticker = '" . $code . "' AND status ='" . static::$approved . "'  AND deleted_at IS NULL ";

        $submissions = DB::select($sql);
        return collect($submissions)->map(function ($x) {
            return (array) $x;
        })->toArray(); //return array
    }

    public static function checkPointsSubmitted($cust_id, $code)
    {
        $sql = "SELECT *
                FROM  " . static::$tableName . "
                WHERE cust_id = '" . $cust_id . "' AND Code_B_Sticker = '" . $code . "' AND points_submitted IS NOT NULL ";

        $submissions = DB::select($sql);
        return collect($submissions)->map(function ($x) {
            return (array) $x;
        })->toArray(); //return array
    }

    public static function getStatus($cust_id, $code)
    {
        $sql = "SELECT status
                FROM  " . static::$tableName . "
                WHERE cust_id = '" . $cust_id . "' AND Code_B_Sticker = '" . $code . "'  AND deleted_at IS NULL ORDER BY created_at DESC";

        $submissions = DB::select($sql);
        return collect($submissions)->map(function ($x) {
            return (array) $x;
        })->toArray(); //return array
    }


    //711 Table

    public static function chkPfSubchain($cust_id)
    {
        // $sql = "SELECT subchain as SubChain
        //         FROM  " . static::$pf711TableName . "
        //         WHERE cust_id = '" . $cust_id . "' AND TRIM(flex_para) = 'COMMERCIAL' ";

        //$sql = "SELECT subchain as SubChain
        //        FROM  " . static::$pf711TableName . "
        //        WHERE cust_id = '" . $cust_id . "' ";

        $sql = "SELECT SubChain
                FROM  " . static::$payoutTable . "
                WHERE ideCust = '" . $cust_id . "' ";

        $subchain = DB::select($sql);
        return collect($subchain)->map(function ($x) {
            return (array) $x;
        })->toArray(); //return array
    }
}
