@extends('layouts.master')

@section('content')

<div class="content-wrapper">
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">Sticker Submission Dashboard
                    @foreach (['danger', 'warning', 'success', 'info'] as $key)
                    @if(Session::has($key))
                    <p class="alert alert-{{ $key }} alert-msg"><i class="fa fa-check" aria-hidden="true"></i>&nbsp;{{ Session::get($key) }}</p>
                    @endif
                    @endforeach
                </div>
                {{-- <div class="col-md-12" style="margin:10px 0;">
                    @can('delete photo-feedback')
                    <button type="button" id="deleteBtn" class="float-right btn btn-default" data-toggle="modal" data-target="#deleteModal" disabled><i class="fa fa-trash" aria-hidden="true"></i></button>
                    @endcan
                </div> --}}

                <br>
                <div class="panel-body">

                    <div id="accordion">
                        <h3 class="filter-header"><i class="fa fa-filter" aria-hidden="true"></i> Filter <i class="fa fa-sort-down"></i></h3>
                        <div id="filter-container">
                            <div class="col-md-6 filter-col-1">

                            </div>
                            <div class="col-md-6 filter-col-2">

                            </div>
                        </div>
                    </div>

                    <table id="pf-sub-tbl" class="display table-bordered dt-responsive">
                        <thead>
                            <tr>
                                <th style="width:5%;">
                                    <input id="multi-all" class="dt-check" type="checkbox">
                                    <label for="multi-all">
                                        <span></span>
                                    </label>
                                </th>
                                {{-- <th>Task Id</th> --}}
                                <th>Cust Id</th>
                                <th>Code A (Batch)</th>
                                <th>Code C (SKU)</th>
                                {{-- <th>Subchain</th> --}}
                                <th>Approved</th>
                                <th>Created at</th>
                                <th>Action</th>
                            </tr>
                        </thead>
                    </table>

                    <table id="filter-temp-tbl">
                        <thead>
                            <tr></tr>
                        </thead>
                    </table>

                </div>
            </div>
        </div>

        <!-- Modal -->
        <div class="modal fade" id="deleteModal" role="dialog">
            <div class="modal-dialog">

                <!-- Modal content-->
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal">&times;</button>
                        <h4 class="modal-title"><i class="fa fa-trash" aria-hidden="true"></i> Delete this Submission?</h4>
                    </div>
                    <div id="modal-body" class="modal-body">
                        <p>Are you sure, you want to delete the selected submission?</p>
                    </div>
                    <div class="modal-footer">
                        <button type="button" id="confirmDelSub" class="btn btn-danger" data-dismiss="modal">Confirm</button>
                        <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                    </div>
                </div>

            </div>
        </div>
    </div>
</div>

@endsection

@section('footer_script')
<link rel="stylesheet" href="{{ asset('css/jquery-ui.css') }}">
<script src="{{ asset('js/jquery-ui/jquery-ui.js') }}"></script>

<script type="text/javascript">
    var base_url = "{{ url('/') }}";

    function call_export_ajax(xml_id_arr = "") {
        console.log(xml_id_arr);
        $.ajax({
            url: "{{ route('response.list_export_response_xml') }} ",
            type: 'POST',
            headers: {
                'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
            },
            data: {
                csrf_token: "{{ csrf_token() }}",
                xml_id: xml_id_arr,
            },
            success: function(data) {
                console.log(data);
                if (data.success) {
                    console.log(data.xml_filenames);
                    var filenames = data.xml_filenames;
                    filenames.forEach(generateTbl);

                    var tbl = "";

                    function generateTbl(item) {
                        tbl += "<tr><td>" + item + "</td></tr>";
                        $("#xml-list-tbl").html(tbl);
                    }
                    $("#successfullyModal").modal('show');
                }
            }
        })
    }

    $(document).ready(function() {

        var csrf_token = "{!! csrf_token() !!}";

        $("#accordion").accordion({
            collapsible: true,
            active: false,
            autoHeight: true
        });

        $('#pf-sub-tbl thead tr').clone(true).appendTo('#filter-temp-tbl thead');
        $("#filter-temp-tbl").hide();

        var pf_tbl = $('#pf-sub-tbl').DataTable({
            serverSide: true,
            processing: true,
            bStateSave: false,
            responsive: true,
            autoWidth: true,
            order: [
                [4, 'desc']
            ],
            columnDefs: [{
                "targets": [0, 3, 5],
                "orderable": false,
            }],
            ajax: {
                url: "{{ route('submissions.index') }}",
                //type: 'GET',
            },
            language: {
                paginate: {
                    next: '>', // or '→'
                    previous: '<' // or '←' 
                }
            },
            // dom:'<lf<t>ip>',
            columns: [{
                    data: 'chk_id',
                    name: 'chk_id'
                },
                // {
                //     data: 'task_id',
                //     name: 'task_id'
                // },
                {
                    data: 'cust_id',
                    name: 'cust_id'
                },
                {
                    data: 'Code_A_Batch',
                    name: 'Code_A_Batch'
                },
                {
                    data: 'Code_C_SKU',
                    name: 'Code_C_SKU'
                },
                {
                    data: 'status',
                    name: 'status',
                    render: function(data, type, row) {
                        console.log(data);
                        var column = "";
                        console.log(data);
                        switch (data) {
                            case 0:
                                column = "<span class='badge badge-danger'>Disapproved</span>";
                                break;
                            case 1:
                                column = "<span class='badge badge-success'>Approved</span>";
                                break;
                        }

                        return column;
                    }
                },
                {
                    data: 'created_at',
                    name: 'created_at'
                },
                {
                    data: 'action',
                    name: 'action'
                }
            ],
            fnDrawCallback: function(oSettings) {

                /*
                $(".export-xml-btn").click(function() {

                    var xml_name = $(this).parent().parent().find('td:nth-child(3)').text();
                    $('#single-xml-msg').text('');
                    $('#single-xml-msg').text('Are you sure, you want to export this XML - ' + xml_name + '?');
                    $('#exportSingleModal').modal('toggle');

                    var xml_id = $(this).data('id');
                    $("#confirmSingleExport").data('id', xml_id);

                });
                */

            },
            initComplete: function(settings, json) {

                var countTr = 0;
                //$('#filter-temp-tbl thead tr:eq(1) th:not(0)').each(function(i) {
                $('#filter-temp-tbl thead tr:eq(1) th').each(function(i) {
                    countTr++;
                    var title = $(this).text();
                    //if (countTr > 1) {

                    $(this).html('<input type="text" placeholder="Search ' + title + '" class="' + title.replace(' ', '_') + '_field filter-field" data-field="' + title + '" class="search-field"/>');
                    //$(this).html('<input type="text" placeholder="Search ' + title + '" />');

                    $('.filter-field', this).on('keyup change', function() {
                        if (pf_tbl.column(i).search() !== this.value) {
                            $('#payout-tbl').css('display', 'table');
                            pf_tbl
                                .column(i)
                                .search(this.value)
                                .draw()
                                .columns.adjust()
                                .responsive.recalc();
                        }
                    })
                    //}
                });


                $('#filter-temp-tbl th input[type=text]').addClass('form-control input-sm').css({
                    "width": "100%"
                });
                $('#filter-temp-tbl th:nth-of-type(1) > input[type=text]').clone(true).appendTo('#filter-container .filter-col-1');
                $('#filter-temp-tbl th:nth-of-type(2) > input[type=text]').clone(true).appendTo('#filter-container .filter-col-1');
                $('#filter-temp-tbl th:nth-of-type(3) > input[type=text]').clone(true).appendTo('#filter-container .filter-col-2');
                //$('#filter-temp-tbl th:nth-of-type(4) > input[type=text]').clone(true).appendTo('#filter-container .filter-col-2');
                //$('#filter-temp-tbl th:nth-of-type(5) > input[type=text]').clone(true).appendTo('#filter-container .filter-col-2');

                $('#filter-container').css({
                    'height': '100%'
                });


                $('.filter-field').keypress(function() {
                    var name = $(this).data('field');
                    var value = $(this).val();
                    console.log(name);
                    console.log('.' + name.replace(' ', '_') + '_field');
                    $("#filter-container ." + name.replace(' ', '_') + '_field').autocomplete({
                        //serviceUrl: '/data/retailer-autocomplete?name=' + name + '&value=' + value,
                        source: function(request, response) {
                            $.getJSON(base_url + '/data/faulty-dispenser-autocomplete?name=' + name + '&value=' + value, function(data) {

                                $('.ui-menu, li.ui-menu-item, .ui-menu-item-wrapper').on('click', function() {
                                    console.log("focus");
                                    $("#filter-container .filter-field").focus();
                                })

                                response($.map(data, function(value, key) {
                                    //console.log(value + "---" + key);
                                    $('.ui-menu').css({
                                        "overflow-y": "auto",
                                        "z-index": "9999",
                                        "height": "120px"
                                    });

                                    return {
                                        label: value,
                                        value: value
                                    };
                                }));

                            });
                        },
                        minLength: 3,
                        delay: 100,
                        change: function() {
                            //var name = $(this).data("field");
                            console.log("change: " + name.replace(' ', '_'));
                            $("#filter-container ." + name.replace(' ', '_') + "_field").trigger("change");
                        }
                    });

                    $('.ui-menu').css({
                        "overflow": "auto"
                    });

                });
            }
        });


        $("#confirmDelSub").click(function() {

            var chk_ids = $('.dt-check:checked:not(#multi-all)').map(function() {
                return $(this).val();
            }).get();

            $.ajax({
                url: "{{ route('photo-feedback.multiple-delete') }}",
                type: 'POST',
                headers: {
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                },
                data: {
                    id: chk_ids
                },
                success: function(result) {
                    $(".dt-check:checked:not(#multi-all)").each(function() {
                        // $(this).parents("tr").remove();
                    });
                    $('#pf-sub-tbl').DataTable().ajax.reload();
                    $(".panel-heading").append('<p class="alert alert-success alert-msg"><i class="fa fa-trash" aria-hidden="true"></i>&nbsp;Submission deleted successfully.</p>');
                    $(".alert-msg").fadeOut(5500, function() {
                        $(this).remove();
                    });
                }
            });

            var x$;
            x$ = $(this).data('action');
            $('#multi-form').attr('action', $('#multi-form').data('action') + x$);
            $('#multi-val').val(JSON.stringify({
                action: x$,
                id: $('.dt-check:checked:not(#multi-all)').map(function() {
                    return $(this).val();
                }).get()
            }));
            //$('#multi-sub').trigger('click');

        });


        $('body').on('change', '#multi-all', function() {
            var a, b;
            a = $('.dt-check:not(#multi-all)');
            b = $('#deleteBtn');
            if ($('#multi-all:checked').length) {
                a.not(':checked').prop('checked', true);
                b.removeClass('disabled').removeAttr('disabled');
                b.css({
                    "background-color": "#B83131",
                    "color": "#fff"
                });
            } else {
                a.filter(':checked').prop('checked', false);
                b.addClass('disabled').attr('disabled', 'disabled');
                b.css({
                    "background-color": "#fff",
                    "color": "#B83131"
                });
            }
        });



        $('body').on('change', '.dt-check:not(#multi-all)', function() {
            var m, b, that, x$;
            m = $('#multi-all');
            b = $('#deleteBtn');
            if (that = $('.dt-check:checked:not(#multi-all)').length) {
                x$ = that < $('.dt-check:not(#multi-all)').length;
                m.prop('indeterminate', x$).prop('checked', !x$);
                b.removeClass('disabled').removeAttr('disabled');
                b.css({
                    "background-color": "#B83131",
                    "color": "#fff"
                });
            } else {
                m.prop('indeterminate', false).prop('checked', false);
                b.addClass('disabled').attr('disabled', 'disabled');
                b.css({
                    "background-color": "#fff",
                    "color": "#B83131"
                });
            }
        });

        var dataArr = [];
        $('#response-tbl tr').filter(':has(:checkbox:checked)').each(function() {
            dataArr.push($(this).find('td').eq(2).text());
            console.log(dataArr);
        });

    });
</script>
@endsection